#!/usr/bin/perl -w
#
#=================================
# project: Sauron DHCP import
# script:  hostname2ip.pl
# version: 1.0\n";
#
# Prevod zaznamu fixed-adress
# z hostname na IP adresu. Tento
# prevod je nutny kvuli importo-
# vaci utilite Saurona.
#
# Zpracovavany soubor musi nej-
# prve projit make_multi_row.pl.
#================================

#print "Split record to more rows in DHCP configuration file\n\n";

while($line = <>){
  if (($line =~ "^#") == 0){
    # nejedna se o komentar
    if ($line =~ /fixed-address[\sa-zA-Z0-9\-\.]*;/){
      $line_pre = $`;
      $line_post = $';
      $hostname = $&;
      $hostname =~ /\s[\sa-zA-Z0-9\-\.]*/;
      $hostname = $&;

      #pokud je hostname IP adresa pak zustane nezmenena
      if ($hostname =~ /[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}/){
        print "$line_pre","fixed-address"," $hostname;$line_post";
      }
      else{
        $result = `host $hostname`;
        #print $result;
	#extrakce IP adresy z odpovedi
	$result =~ /[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}/;
	$ip_address = $&;
	if ($ip_address =~ /[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}/){
	  #nalezeno
          #print "$ip_address\n";
	}
	else{
	  #chyba pri prevodu
	  #print "$ip_address\n";
	}
        print "$line_pre","fixed-address"," $ip_address;$line_post";
      }
    } #if radek s parametrem "fixed-address"
    else{
      print $line;
    }
    
  } #if
  else{
    print $line;
  }
} #while

