#!/usr/bin/perl -w
#
#=================================
# project: Sauron DHCP import
# script:  prepare_cheb.pl
# version: 1.0\n";
#
# Uprava konfiguracniho souboru
# z chebu - presun globalnich
# options do skupiny, zruseno
# zdvojeni skupiny.
#
# Zpracovavany soubor musi nej-
# prve projit make_multi_row.pl.
#================================


#prazdne pole
@options = ();

$left_br = 0;
$right_br = 0;

$group = 0;
$unleash = 0;
$subnet = 0;

@lines = <>;

#likvidace odsazeni radky
foreach(@lines){
  $line = $_;
  $line =~ /^[\s]*/;
  $line = $';
  if (($line =~ /^#.*/) == 0){
     push @lines2, $line;
  }
} #foraeach
@lines = @lines2;         


#vlastni zpracovani 
@lines2 = ();
push @lines2, "\n\n#Configuration from Cheb\n\n";
foreach(@lines){
  $line = $_;
  if (($line =~ "^#") == 0){
    $miss_line = 0;
    # nejedna se o komentar
    if ($line =~ /{/) {
      $left_br++;
    }
    if ($line =~ /}/) {
      $right_br++;
    }
    if ($line =~ /^[\s]*group/){    
      $group++;
      $miss_line = 1;
      $left_br--; #protoze je vynechano
    }
    if ($line =~ /^[\s]*subnet/){    
      $subnet++;
    }
    if ($subnet == 0){
      push @options, $line;
    }
    else{
      if (($unleash == 0) && ($group == 1)) {
        push @lines2, "group {\n";
	$left_br++;
        foreach(@options){
	  push@ lines2, $_;
	}
        $unleash = 1;
      }

      if ($right_br > $left_br){
        $miss_line = 1;
      }

      if ($miss_line == 0){
        push @lines2, $line;
      }
    
    }
  } #if
} #while
@lines = @lines2;

#vygenerovani spravneho odsazeni
#
@lines2 = ();
$n_open = 0;
foreach(@lines){
  $line = $_;
  if ($line =~ /[^}]*}[^}]*/){
    $n_open--;
  }
  $odsaz = "";
  for($i=1;$i<=$n_open;$i++){
    $odsaz = $odsaz."  ";
  }
  push @lines2, "$odsaz$line";
  if ($line =~ /[^{]*{[^{]*/){
    $n_open++;
  }
  #print "nopen = $n_open\n";
} #foreach
@lines = @lines2;

#vypis vysledku
foreach(@lines){
  print $_;
}
                                                          
