#!/usr/bin/sh

#COPYRIGHT 1996 Pavel Martak
#
#Usage : 
# test_address.sh file file2 subnet base hadress 
PREFIX=/etc/namedb/
NET=$3
HA=$4
FILE=$1
FILE2=$2

FLAG=`/usr/bin/grep -c -w $HA ${PREFIX}$FILE`

export NET

/usr/bin/rm syndrom*
if [ $FLAG != "0" ]
        then
	 echo "*******************************************************"
	 echo "		Thereis already eth: $HA"
	 FLAG=`/usr/bin/grep -w $HA ${PREFIX}$FILE`
	 echo $FLAG
	 echo "*******************************************************"
fi

/usr/bin/egrep  "^[^\#\.\:\ \t][\ \t]*.*ip=$NET\..*" ${PREFIX}$FILE > ${PREFIX}syndrom.txt
/usr/bin/egrep  ".*IN.*A.*$NET\..*" ${PREFIX}$FILE2 >> ${PREFIX}syndrom.txt
	
/usr/bin/awk '/^[^\#\.\:\ \t][\ \t]*.*ip\=.*/{FS=":" ; split($4,arr,"="); split (arr[2],numb,"."); print numb[4]}
     /[0-1a-zA-Z\-]+[ |\t]*IN.*A.*/{FS=" " ; split ($4,numb1,"."); print numb1[4]}
     /^[ |\t]*IN.*A.*/{FS=" "; split ($3,numb2,"."); print numb2[4] }
' ${PREFIX}syndrom.txt > ${PREFIX}syndrom.ip


/usr/bin/sort -n ${PREFIX}syndrom.ip > ${PREFIX}syndrom.ip.sort

echo "
Free IP adress in bootptab and zone database: 
"

/usr/bin/nawk 'BEGIN{A=0; B=0}
	{ B=$0; DIFF= B - A;
	if ( DIFF > 1) { A = A + 1; print ENVIRON["NET"]"."A" - "ENVIRON["NET"]"."B-1};
	 A=B }' ${PREFIX}syndrom.ip.sort

TOP=`/usr/bin/sort -n -r ${PREFIX}syndrom.ip | /usr/bin/awk '{print $0; exit}'`
echo "
Last used IP address on subnet $NET is ${NET}.${TOP}"
