#!/usr/bin/perl -w
#

#$HN_EXTENSION = ".zcu.cz";


#print "\nUsed BOOTP tags detection\n\n";

#pocet tagu v souboru
$ba = 0;
$bf = 0;
$bs = 0;
$cs = 0;
$df = 0;
$dn = 0;
$ef = 0;
$gw = 0;
$ds = 0;
$ha = 0;
$hd = 0;
$hn = 0;
$ht = 0;
$lm = 0;
$lg = 0;
$lp = 0;
$ns = 0;
$nt = 0;
$ra = 0;
$rl = 0;
$rp = 0;
$sa = 0;
$sm = 0;
$sw = 0;
$Tnnn = 0;
$tc = 0;
$to = 0;
$ts = 0;
$vm = 0;
$yd = 0;
$yp = 0;

#-------------------------------------------------------------------
#nacteni celeho souboru do pameti
#-------------------------------------------------------------------
@lines = <>;

#-------------------------------------------------------------------
#preprocessing - vyhazeni komentaru
#-------------------------------------------------------------------
@lines2 = ();
foreach(@lines){
  if (($_ =~ "^#") == 0){
    push @lines2, $_;
  }
}
@lines = @lines2;

#-------------------------------------------------------------------
#prevod viceradkovych zaznamu na jednoradkove
#-------------------------------------------------------------------
@lines2 = ();
$add_next_line = 0;
$temp_line = "";
for($i=0; $i != $#lines+1;++$i){
  if ($lines[$i] =~ /:\\/){
    #dalsi radka bude pridana k teto
    $add_next_line = 1;
    $temp_line = "$temp_line$`";
  }
  else{
    if ($add_next_line == 0){
      #radka je kompletni - primo zapsat
      push @lines2, $lines[$i];
    }
    else{
      #konec viceradkove "radky"
      $temp_line = "$temp_line$lines[$i]\n";
      push @lines2, $temp_line;
      $temp_line = "";
    }
    $add_next_line = 0;
  }
  #print "temp = '$temp_line', addNL= $add_next_line\n";
}

#je-li po skonceni "roznactena" multiradka - doplneno posledni radkou
if ($add_next_line == 1){
      $temp_line = "$temp_line\n";
      push @lines2, $temp_line;
}
@lines = @lines2;

#foreach(@lines){
#print $_;
#}
#die;

#-------------------------------------------------------------------
#preusporadani zaznamu tak, aby po radce typu ".net" nasledovaly vsechny zaznamy patrici do teto skupiny
#pak nasleduje dalsi skupina a jeji clenove ...
#-------------------------------------------------------------------
$group_exists = 1;
$active_group = "";
@final = ();
while ($group_exists == 1){
  @lines2 = ();
  #nalezeni prvniho radku se zaznamem skupiny
  $group_exists = 0;
  foreach (@lines){
    if ($_ =~ /^\./){
      $group_exists = 1;
      $active_group = $_;
      last;
    }
  }
  if ($group_exists == 1){
    push @final, "\n\n$active_group";
  }
 
  #zpracovani souboru dane skupiny

  foreach(@lines){
    $line = $_;
    if ($_ eq $active_group){
      #tj. prave zpracovavana skupina - ta uz je zapsana, nedeje se nic
    }
    else{
      if ($_ =~ /^\./){
        #zaznam jine skupiny
        push @lines2, $line;
      }
      else{
        #zaznam hostu
	if ($_ =~ /tc=\.[a-zA-Z0-9]*:/){
  	  $name1 = $&;
	  $name1 =~ /\.[a-zA-Z0-9]*/;
	  $name1 = $&;
	  $active_group =~ /^\.[a-zA-Z0-9]*/;
	  $name2 = $&;
	  #print "'$name1 == $name2\n";
	  if ($name1 eq $name2){
	    push @final, $line;
	  }
	  else{
            push @lines2, $line;
	  }
	}
	else{
	  push @lines2, $line;
	}
      }
    }
  } #foreach
 
  @lines = @lines2;
} #while

#---------------------------------------------------------------------------------------------------------------------
#serazeni pro dalsi zpracovani - nejprve jdou hostove bez skupiny a pak vzdy definice skupiny nasledovana svymi hosty.
#---------------------------------------------------------------------------------------------------------------------
@lines = ();
foreach(@lines2){
  push @lines, $_;
}
foreach(@final){
  push @lines, $_;
}

#foreach(@lines){
#  print $_;
#}
#die;

#prevod tagu z bootp do dhcp
#
$open_group = 0;
foreach(@lines){
  $line = $_;
  if (($line =~ /^[\s]*$/) == 0){
    #nejde o komentar
    if (($line =~ "^\.") == 0){
      #group zaznam
      if ($open_group == 1){
        print "}\n\n";
      }
      print "group {\n";
      $open_group = 1;
      &process_group($_);
      #print $_;
    }
    else{
      #host zaznam
      &process_host($_);
    }
  }
  else{
    #jde o prazdnou radku - vynechana;
  }
}
#dokonceni posledni skupiny - je-li nejaka otevrena
if ($open_group == 1){
  print "}\n\n";
}

#vypis statistiky jednotlivych tagu
print "#\n# Numbers of detected tags:\n#\n";
print "#   $ba x 'ba'\n";
print "#   $bf x 'bf'\n";
print "#   $bs x 'bs'\n";
print "#   $cs x 'cs'\n";
print "#   $df x 'df'\n";
print "#   $dn x 'dn' (converted)\n";
print "#   $ef x 'ef'\n";
print "#   $gw x 'gw'\n";
print "#   $ds x 'ds' (converted)\n";
print "#   $ha x 'ha' (converted)\n";
print "#   $hd x 'hd'\n";
print "#   $hn x 'hn'\n";
print "#   $ht x 'ht'\n";
print "#   $lm x 'lm'\n";
print "#   $lg x 'lg'\n";
print "#   $lp x 'lp'\n";
print "#   $ns x 'ns'\n";
print "#   $nt x 'nt'\n";
print "#   $ra x 'ra'\n";
print "#   $rl x 'rl'\n";
print "#   $rp x 'rp'\n";
print "#   $sa x 'sa'\n";
print "#   $sm x 'sm' (converted)\n";
print "#   $sw x 'sw'\n";
print "#   $Tnnn x 'Tnnn'\n";
print "#   $tc x 'tc' (converted)\n";
print "#   $to x 'to'\n";
print "#   $ts x 'ts'\n";
print "#   $vm x 'vm'\n";
print "#   $yd x 'yd'\n";
print "#   $yp x 'yp'\n";


#=====================================================================================================

sub process_group{
  $line = $_;
  $first = 0;
  $filename_bf = "";
  $filename_hd = "";
  while ($line =~ ":"){ 
    $line_part1 = $`;
    #$line_part2 = $&;
    $line_part3 = $';

    if ($first == 0){
      #prvni zaznam v radku - nazev skupiny
      #nic se nevypisuje
      $first = 1;
    }
    else{
      $line =~ "[^:]*";
      #print "$&\n";
      &process_gtags($&);
    }
    $line = $line_part3;
  }
  if ((($filename_bf eq "") == 0) & (($filename_hd eq "") == 0)){
    print "\tfilename \"$filename_hd/$filename_bf\";\n";
  }
  else{
    print "\t#path to bootfile not complete (missing BF or HD)\n";
  }
  #  print "\t}\n";
} #process_group

#=====================================================================================================

sub process_host{
  $line = $_;
  $first = 0;
  $filename_bf = "";
  $filename_hd = "";
  while ($line =~ ":"){ 
    $line_part1 = $`;
    #$line_part2 = $&;
    $line_part3 = $';

    if ($first == 0){
      #prvni zaznam v radku - hostname
      $line =~ "[^:]*";
      $hostname = $&;
      print "\thost $hostname {\n";
      $first = 1;
    }
    else{
      $line =~ "[^:]*";
      &process_htags($&);
    }
    $line = $line_part3;
  }
  print "\t}\n";
} #process_host
	
#=====================================================================================================

sub process_gtags{
  foreach(@_){
     #print "gtag = '$_'\n";
          #zjisteni typu tagu a nasledny zapis
	  if ($_ =~ "^ba"){
	    $ba++;
	    #&process_ba("$_$'");
	  }
	  if ($_ =~ "^bf"){
	    $bf++;
	    &process_bf("$_$'");
	  }
	  if ($_ =~ "^bs"){
	    $bs++;
	    #&process_bs("$_$'");
	  }
	  if ($_ =~ "^cs"){
	    $cs++;
	    #&process_cs("$_$'");
	  }
	  if ($_ =~ "^(ds|ip)"){
	    $ds++;
	    &process_ip_g("$_$'");
	  }
	  if ($_ =~ "^df"){
	    $df++;
	    #&process_df("$_$'");
	  }
	  if ($_ =~ "^dn"){
	    $dn++;
	    &process_dn("$_$'");
	  }
	  if ($_ =~ "^ef"){
	    $ef++;
	    #&process_ef("$_$'");
	  }
	  if ($_ =~ "^gw"){
	    $gw++;
	    #&process_gw("$_$'");
	  }
	  if ($_ =~ "^ha"){
	    $ha++;
	    &process_ha("$_$'");
	  }
	  if ($_ =~ "^hd"){
	    $hd++;
	    &process_hd("$_$'");
	  }
	  if ($_ =~ "^hn"){
	    $hn++;
	    &process_hn_g("$_$'");
	  }
	  if ($_ =~ "^ht"){
	    $ht++;
	    #&process_ht("$_$'");
	  }
	  if ($_ =~ "^lm"){
	    $lm++;
	    #&process_lm("$_$'");
	  }
	  if ($_ =~ "^lg"){
	    $lg++;
	    #&process_lg("$_$'");
	  }
	  if ($_ =~ "^lp"){
	    $lp++;
	    #&process_lp("$_$'");
	  }
	  if ($_ =~ "^ns"){
	    $ns++;
	    #&process_ns("$_$'");
	  }
	  if ($_ =~ "^nt"){
	    $nt++;
	    #&process_nt("$_$'");
	  }
	  if ($_ =~ "^ra"){
	    $ra++;
	    #&process_ra("$_$'");
	  }
	  if ($_ =~ "^rl"){
	    $rl++;
	    #&process_rl("$_$'");
	  }
	  if ($_ =~ "^rp"){
	    $rp++;
	    #&process_rp("$_$'");
	  }
	  if ($_ =~ "^sa"){
	    $sa++;
	    #&process_sa("$_$'");
	  }
	  if ($_ =~ "^sw"){
	    $sw++;
	    #&process_sw("$_$'");
	  }
	  if ($_ =~ "^sm"){
	    $sm++;
	    &process_sm("$_$'");
	  }
	  if ($_ =~ "^tc"){
	    $tc++;
	    #&process_tc("$_$'");
	  }   	
	  if ($_ =~ "^to"){
	    $to++;
	    #&process_to("$_$'");
	  }
	  if ($_ =~ "^ts"){
	    $ts++;
	    #&process_ts("$_$'");
	  }
	  if ($_ =~ "^vm"){
	    $vm++;
	    &process_vm("$_$'");
	  }
	  if ($_ =~ "^T[0-9]{3}"){
	    $Tnnn++;
	    #&process_Tnnn("$_$'");
	  }
	  if ($_ =~ "^yd"){
	    $yd++;
	    #&process_yd("$_$'");
	  }
	  if ($_ =~ "^yp"){
	    $yp++;
	    #&process_yp("$_$'");
	  }
          #print "'$_$line_part2'\n";
 }
} #sub

#=====================================================================================================

sub process_htags{
  foreach(@_){
    #print "htag = '$_'\n";
          #zjisteni typu tagu a nasledny zapis
	  if ($_ =~ "^ba"){
	    $ba++;
	    #&process_ba("$_$'");
	  }
	  if ($_ =~ "^bf"){
	    $bf++;
	    &process_bf("$_$'");
	  }
	  if ($_ =~ "^bs"){
	    $bs++;
	    #&process_bs("$_$'");
	  }
	  if ($_ =~ "^cs"){
	    $cs++;
	    #&process_cs("$_$'");
	  }
	  if ($_ =~ "^(ds|ip)"){
	    $ds++;
	    &process_ip_h("$_$'");
	  }
	  if ($_ =~ "^df"){
	    $df++;
	    #&process_df("$_$'");
	  }
	  if ($_ =~ "^dn"){
	    $dn++;
	    &process_dn("$_$'");
	  }
	  if ($_ =~ "^ef"){
	    $ef++;
	    #&process_ef("$_$'");
	  }
	  if ($_ =~ "^gw"){
	    $gw++;
	    #&process_gw("$_$'");
	  }
	  if ($_ =~ "^ha"){
	    $ha++;
	    &process_ha("$_$'");
	  }
	  if ($_ =~ "^hd"){
	    $hd++;
	    &process_hd("$_$'");
	  }
	  if ($_ =~ "^hn"){
	    $hn++;
	    &process_hn_h(@line_part1);
	  }
	  if ($_ =~ "^ht"){
	    $ht++;
	    #&process_ht("$_$'");
	  }
	  if ($_ =~ "^lm"){
	    $lm++;
	    #&process_lm("$_$'");
	  }
	  if ($_ =~ "^lg"){
	    $lg++;
	    #&process_lg("$_$'");
	  }
	  if ($_ =~ "^lp"){
	    $lp++;
	    #&process_lp("$_$'");
	  }
	  if ($_ =~ "^ns"){
	    $ns++;
	    #&process_ns("$_$'");
	  }
	  if ($_ =~ "^nt"){
	    $nt++;
	    #&process_nt("$_$'");
	  }
	  if ($_ =~ "^ra"){
	    $ra++;
	    #&process_ra("$_$'");
	  }
	  if ($_ =~ "^rl"){
	    $rl++;
	    #&process_rl("$_$'");
	  }
	  if ($_ =~ "^rp"){
	    $rp++;
	    #&process_rp("$_$'");
	  }
	  if ($_ =~ "^sa"){
	    $sa++;
	    #&process_sa("$_$'");
	  }
	  if ($_ =~ "^sw"){
	    $sw++;
	    #&process_sw("$_$'");
	  }
	  if ($_ =~ "^sm"){
	    $sm++;
	    &process_sm("$_$'");
	  }
	  if ($_ =~ "^tc"){
	    $tc++;
	    #&process_tc("$_$'");
	  }   	
	  if ($_ =~ "^to"){
	    $to++;
	    #&process_to("$_$'");
	  }
	  if ($_ =~ "^ts"){
	    $ts++;
	    #&process_ts("$_$'");
	  }
	  if ($_ =~ "^vm"){
	    $vm++;
	    &process_vm("$_$'");
	  }
	  if ($_ =~ "^T[0-9]{3}"){
	    $Tnnn++;
	    #&process_Tnnn("$_$'");
	  }
	  if ($_ =~ "^yd"){
	    $yd++;
	    #&process_yd("$_$'");
	  }
	  if ($_ =~ "^yp"){
	    $yp++;
	    #&process_yp("$_$'");
	  }
          #print "'$line_part1$line_part2'\n";
  }
} #sub

#=====================================================================================================
#=====================================================================================================
#=====================================================================================================

#funkce pro predzpracovani jednotlivych tagu

sub process_ip_h{
  foreach(@_){
    $_ =~ "=";
    print "\t\tfixed-address $';\n";
  }
}

#=====================================================================================================

sub process_ip_g{
  foreach(@_){
    $_ =~ "=";
    print "\toption domain-name-servers\t";
    $temp = $';
    #print "'$temp'";
    $temp_first = 0;
    while ($temp =~ /([0-9]){1,3}\.([0-9]){1,3}\.([0-9]){1,3}\.([0-9]){1,3}/){
      if ($temp_first == 0){
        $temp_first = 1;
        print $&;
      }
      else{
        print ", $&";
      }
      $temp = $';
    }
    
    print";\n";
  }
}

#=====================================================================================================

sub process_ha{
  foreach(@_){
    $process_line = $_;
    $process_line =~ "=";
    print "\t\thardware ethernet ";
  
    $line_cycle = $';
    for($i=1;$i<=6;$i++){
      $pom = $line_cycle;
      $pom =~ "^[a-zA-Z0-9]{2}";
      print "$&";
      $line_cycle = $';
      if ($i<6){
        print ":";
      }
    }
  
    print ";\n";
  }
}

#=====================================================================================================
sub process_dn{
  foreach(@_){
    print "\toption domain-name\t";
    $_ =~ "="; 
    $temp = $';
    $temp_first = 0;
    while ($temp =~ /[a-zA-Z0-9\.\-\_]+/){
      if ($temp_first == 0){
        print "\"$&\"";
	$temp_first = 1;
      }
      else{
        print ", \"$&\"";
      }
      $temp = $';
    }
    print ";\n";
  }
}

#=====================================================================================================
sub process_sm{
  foreach(@_){
    $_ =~ "=";
    $temp = $';
    $temp =~ /([0-9]){1,3}\.([0-9]){1,3}\.([0-9]){1,3}\.([0-9]){1,3}/;
    print "\toption subnet-mask\t$&;\n";
  }
}

#=====================================================================================================

sub process_hn_h{
  print "\toption\n";
}

#=====================================================================================================

sub process_hn_g{
  print("\tuse-host-decl-names on;\n");
}

#=====================================================================================================

sub process_bf{
  foreach(@_){
    $_ =~ /.*=\s*/;
    $pom = $';
    $pom =~ /[^\s]*/;
    $pom2 = $&;
    $filename_bf = $pom2;
    #print("\tbf = '$filename_bf';\n");
  }
}

#====================================================================================================

sub process_hd{
  foreach(@_){
    $_ =~ /.*=\s*/;
    $pom = $';
    $pom =~ /[^\s]*/;
    $pom2 = $&;
    $filename_hd = $pom2;
    #print("\thd = '$filename_hd';\n");
  }
}

#=====================================================================================================

sub process_vm{
  foreach(@_){
    $_ =~ /.*=\s*/;
    $pom = $';
    $pom =~ /[^\s]*/;
    $pom2 = $&;
    if ($pom =~ /1048/){
      print("\talways-reply-$pom2 on;\n");
    }
    else{
      print("\talways-reply-$pom2;\n");
    }
  }
}

#=====================================================================================================
