#!/bin/sh

SRC_PATH="/afs/zcu.cz/common/etc/dhcp3"
DEST_PATH="/etc/dhcp3"

DIFF=0

for i in $SRC_PATH/*
do
    if ! cmp -s $i $DEST_PATH/`basename $i` 
    then
        cp $i $DEST_PATH/ 
        DIFF=1
    fi 
done

if [ "$DIFF" == "1" ]
then
    /etc/init.d/dhcp3-server stop
    sleep 2
    /etc/init.d/dhcp3-server start
fi
