#!/bin/sh
PREFIX=/etc/namedb/
DATE=`/bin/date +%Y%m%d`
echo "GENERATING NEW SOARECORD
DATE ..... $DATE" > ${PREFIX}soa_update.log;
DATESOA=${DATE}00;
echo "DATESOA .. $DATESOA" >> ${PREFIX}soa_update.log;

FROM=${PREFIX}$1

OLDSOA=`/usr/bin/nawk '/.*@.*IN.*SOA/{ 
		getline;
	        split($0,SOA," ")
		print (SOA[1]); 
		}' $FROM`
echo "OLDSOA ... $OLDSOA" >> ${PREFIX}soa_update.log;
DIFF=`expr $DATESOA - $OLDSOA`
echo "DIFF ..... $DIFF" >> ${PREFIX}soa_update.log;

if [ $DIFF -gt 0 ]
 then
	echo " DIFF is greater" >> ${PREFIX}soa_update.log
	DATESOA=`expr $DATESOA + 1 `
 else 
	echo " DIFF is smaller" >> ${PREFIX}soa_update.log
	DATESOA=`expr $OLDSOA + 1 `
fi

echo "DATESOA .. $DATESOA" >> ${PREFIX}soa_update.log;
export DATESOA

nawk '/.*@.*IN.*SOA/{FLAG=1;
		print; 
		getline;
	        NEWSERIAL=ENVIRON["DATESOA"];
		print ("\t\t\t\t"NEWSERIAL,"\t; Serial number"); 
		getline;
		REFRESH=$0;
		print REFRESH; 
		getline;
		RETRY=$0;
		print RETRY;
 		getline;
		EXPIRE=$0;
		print EXPIRE;
		getline;
		TTL=$0;
		print TTL;
		getline; 
		SLASH=$0;
		FLAG=0;}
	/.*/{ if ( FLAG == 0 ) print;}' $FROM





