#! /usr/bin/perl -w
#

#=================================
# project: Sauron DHCP import
# script:  modify_groups2.pl
# version: 1.0\n";
#
# Odstraneni vnorenych skupin,
# skript odstrani vzdy pouze 
# jedno vnereni skupiny - je-li
# vnorovani vyssiho radu, pak je 
# potreba tento skript pustit
# vicekrat za sebou. 
#
# Stupen zanoreni lze zjistit 
# pomoci skriptu
# find_groups.pl
#================================
#

$n_open = 0;

@lines = <>;
@lines2 = ();

#likvidace odsazeni radky
foreach(@lines){
  $line = $_;
  $line =~ /^[\s]*/;
  $line = $';
  if (($line =~ /^#.*/) == 0){
    push @lines2, $line;
  }
} #while
@lines = @lines2;

#odstraneni vnorenych skupin ze skupin level1
@group_level1 = ();	#radky z vnorene skupiny
@options_level1 = ();
@lines2 = ();
@output = ();
$open_groups = 0;
$open_brackets = 0;
@groups_brackets = (0, 0, 0, 0, 0);
$host_open = 0;
$host_open_brackets = 0;
foreach(@lines){
 $line = $_;
 if ($line =~ /{/){
   $open_brackets++;
   #print "open = $open_brackets\n";
   if ($line =~ "group"){
     $groups_brackets[$open_groups] = $open_brackets;
     $open_groups++;
   }
 }
 if ($line =~ /^host\s*.*/){
   $host_open = 1;
   $host_open_brackets = $open_brackets;
 }

 if ($open_groups < 2){
   if ($host_open == 1){
     push @lines2, $line;
   }
   else{
     if (!((($line =~ /^group\s*{/) == 1) || (($open_brackets == $groups_brackets[$open_groups-1]) && (($line =~ /^\s*}\s*$/) == 1)) || ($open_groups != 1))){
       push @options_level1, $line;
     }
     push @lines2, $line;
   }
 }
 else{
   push @group_level1, $line;
 }

 if ($line =~ "}"){
   if (($open_brackets == $groups_brackets[$open_groups-1]) && ($open_groups>0)){
      $open_groups--;
      $host_open = 0;
   }
   $open_brackets--;
 }

 if ($open_groups == 0){
   #tj. muze zacit dalsi skupina
   foreach(@lines2){  #zapis skupiny
     push @output, $_;
   }
   #zapis "skupinoveho vnitrku" skupiny
   $open_groups2 = 0;
   $open_brackets2 = 0;
   @groups_brackets2 = (0, 0, 0, 0, 0);   
   foreach(@group_level1){
     #zapis parametru (options) zdedenych z nadrazene skupiny do vsech presouvanych skupin
     #--------------------------------------     
     if ($_ =~ /{/){
       $open_brackets2++;
       if ($_ =~ /\s*group\s*{.*/){
         $groups_brackets2[$open_groups2] = $open_brackets2;
         $open_groups2++;
       }
     }
     
     if ($_ =~ "}"){
       if (($open_brackets2 == $groups_brackets2[$open_groups2-1]) && ($open_groups2>0)){
          $open_groups2--;
       }
       $open_brackets2--;
     }
		       
          
     #--------------------------------------
     if (($_ =~ /\s*group\s*{.*/) && ($open_groups2 == 1)){
       push @output, $_;
       foreach(@options_level1){
         push @output, $_;
       }
     }
     else{
       push @output, $_;
     }
   }
   #ukonceny operace s jednou skupinou -> vynulovani poli pro dalsi skupinu
   @lines2 = ();
   @group_level1 = ();
   @options_level1 = ();
 }
} #foreach
@lines = @output;

#vygenerovani spravneho odsazeni
#
@lines2 = ();
foreach(@lines){
  $line = $_;

    if ($line =~ /[^}]*}[^}]*/){
      $n_open--;
    }
    $odsaz = "";
    for($i=1;$i<=$n_open;$i++){
      $odsaz = $odsaz."  ";
    }
    push @lines2, "$odsaz$line";

    if ($line =~ /[^{]*{[^{]*/){
      $n_open++;
    }
    #print "nopen = $n_open\n";
} #foreach
@lines = @lines2;

#vypis vysledku
foreach(@lines){
  print $_;
}


  
